#include "mbed.h"

#define MAX_STRIPS 8
#define MAX_SENSORS 5

#define NUM_SENSORS MAX_STRIPS*MAX_SENSORS // reserve addresses for 8 strips with 6 sensors on each
#define PRECISION 0

#define FREESCALE_ADDRESS 0xC0
#define SENSOR_ALL_ON 0x0C
#define SENSOR_ALL_OFF 0x0D


/**********************************VARIABLE_DEFINITIONS**********************************/
//SDA, SCL
I2C i2c(PTE25, PTE24);
 
const int addr = 0x00;

Serial pc(USBTX, USBRX);

/**********************************SUPPORT_FUNCTIONS**********************************/

void startDataConversion(){
    char cmd[4];
        
    //first set of commands
    cmd[0] = 0x0C; //activate all sensors
    cmd[1] = 0xC0; //start data conversion
    cmd[2] = 0x12;
    cmd[3] = 0x0D; //disable the sensors
    i2c.write(addr, cmd, 4);
    
    //wait for data to be processed
    wait(2); //2 ms (rounded up 1.6ms)
}

//given a sensor number, get the value
int read_Sensor(int sensor){
    //startDataConversion();
    
    char cmd[4];
    
    //second set of commands
    switch(sensor){ //activate the sensor of your choosing
        case 1:
            cmd[0] = 0x00;
            break;
        case 2:
            cmd[0] = 0x02;
            break;
        case 3:
            cmd[0] = 0x04;
            break; 
        case 4:
            cmd[0] = 0x06;
            break; 
        case 5:
            cmd[0] = 0x08;
            break;  
    } 
    
    cmd[1] = 0xC0; //read pressure and temperature
    cmd[2] = 0x00;
    cmd[3] = 0xC1;
    i2c.write(addr, cmd, 4);
    
    //read sensor
    char valIn[4];
    i2c.read(addr, valIn, 4); //read the next 4 bytes
    
    //deactivate sensor
    cmd[0] = cmd[0] + 1; //increment by 1 to get the OFF code
    i2c.write(addr, cmd[0], 1);
    
    
    
}
    

/**********************************MAIN_FUNCTION**********************************/
 
int main() {
    char cmd[7];
    i2c.frequency(100000);
    while (1) {

    }
}
